org.apache.catalina

## Interface Group

All Superinterfaces:
  Principal

All Known Implementing Classes:
  AbstractGroup, MemoryGroup

    public interface Group
    extends Principal

Abstract representation of a group of `User`s in a `UserDatabase`. Each user that is a member of this group inherits the `Role`s assigned to the group.

Since:
  4.1
Author:
  Craig R. McClanahan

### Method Summary

Methods
`void` `addRole(Role role)` Add a new `Role` to those assigned specifically to this group.
`String` `getDescription()` Return the description of this group.
`String` `getGroupname()` Return the group name of this group, which must be unique within the scope of a `UserDatabase`.
`Iterator<Role>` `getRoles()` Return the set of `Role`s assigned specifically to this group.
`UserDatabase` `getUserDatabase()` Return the `UserDatabase` within which this Group is defined.
`Iterator<User>` `getUsers()` Return the set of `User`s that are members of this group.
`boolean` `isInRole(Role role)` Is this group specifically assigned the specified `Role`?
`void` `removeRole(Role role)` Remove a `Role` from those assigned to this group.
`void` `removeRoles()` Remove all `Role`s from those assigned to this group.
`void` `setDescription(String description)` Set the description of this group.
`void` `setGroupname(String groupname)` Set the group name of this group, which must be unique within the scope of a `UserDatabase`.

### Methods inherited from interface java.security.Principal

`equals, getName, hashCode, toString`

### Method Detail

#### getDescription

    String getDescription()

Return the description of this group.

#### setDescription

    void setDescription(String description)

Set the description of this group.

Parameters:
  `description` - The new description

#### getGroupname

    String getGroupname()

Return the group name of this group, which must be unique within the scope of a `UserDatabase`.

#### setGroupname

    void setGroupname(String groupname)

Set the group name of this group, which must be unique within the scope of a `UserDatabase`.

Parameters:
  `groupname` - The new group name

#### getRoles

    Iterator<Role> getRoles()

Return the set of `Role`s assigned specifically to this group.

#### getUserDatabase

    UserDatabase getUserDatabase()

Return the `UserDatabase` within which this Group is defined.

#### getUsers

    Iterator<User> getUsers()

Return the set of `User`s that are members of this group.

#### addRole

    void addRole(Role role)

Add a new `Role` to those assigned specifically to this group.

Parameters:
  `role` - The new role

#### isInRole

    boolean isInRole(Role role)

Is this group specifically assigned the specified `Role`?

Parameters:
  `role` - The role to check

#### removeRole

    void removeRole(Role role)

Remove a `Role` from those assigned to this group.

Parameters:
  `role` - The old role

#### removeRoles

    void removeRoles()

Remove all `Role`s from those assigned to this group.